// test.wdl
var video_mode = 7;
var video_screen = 1;
var video_depth = 32;
var shadow_offset = 0.5;
var fps_max = 60;
var save[3];
path "physics system";
path "game files";
// define a splash screen with the required A4/A5 logo
bmap splashmap = <logodark.pcx>; // the default logo in templates
panel splashscreen 
{
	layer = 50;
	bmap = splashmap;
	flags = refresh,d3d;
}
include <physics.wdl>;

var turnto[3];
var lives = 5;
var bar_life = 100;
var bar_life_d;
var spikes = 5;
var spike_life = 100;
var spike_life_d;

font arial_font = "Arial",1,20;

text enemy_text{font = arial_font;string = "this is a spikeball\n crash into to hurt him(or yourself)\nthe lowest one in a crash loses life";}
text bounce_text{string = "This object lets you jump. Just jump on it.";font = arial_font;}

bmap heart =<heart.bmp>;
bmap bar =<bar.bmp>;
bmap spike =<spike.bmp>;
function main
{
	spikes = 4;
	bar_life = 100;
	lives = 5;
	level_load("test.wmb");
	splashscreen.pos_x = (screen_size.x - bmap_width(splashmap))/2;
	splashscreen.pos_y = (screen_size.y - bmap_height(splashmap))/2;
	splashscreen.visible = on;
	wait(-2);
	splashscreen.visible = off;
	bmap_purge(splashmap);
	while(1)
	{
		bounce_text.visible = off;
		enemy_text.visible = off;
		wait(1);
	}
}

define power,skill1;

define enemy_live,skill80;//just a skill
///////////////////////////////////////////////////////////////////////////
text talk1_text{font = arial_font;string = "welcome in the physics jump&run demo\n press the cursor keys to walk\n press the A and D to turn \nand space to jump\n I hope you enjoy it...\n made by Roel Smit";}
action talk1
{
	while(key_space == 0){wait(1);}
	wait(-1);
	while(key_space == 0){wait(1);}
	wait(-1);
	while(key_space == 0){wait(1);}
	while(!player){wait(1);}
	while(player)
	{
		talk1_text.visible = off;
		if(vec_dist(my.x,player.x) < 300)
		{
			talk1_text.visible = on;
		}
		wait(1);
	}
}
text talk2_text{font = arial_font;string = "You won! if You like to use this physics system, the physics system is located in the \\physic system folder";}
action talk2
{
	var mycounter;
	while(!player){wait(1);}
	while(player)
	{
		talk2_text.visible = off;
		if(vec_dist(my.x,player.x) < 300)
		{
			vec_set(player.absdist_x,nullvector);
			player.gravity_active = cos(mycounter);
			mycounter+=1*time;
			talk2_text.visible = on;
		}
		wait(1);
	}
}
///////////////////////////////////////////////////////////////////////////
action player_act
{
	player = me;
	while(key_space == 0){wait(1);}
	wait(-1);
	while(key_space == 0){wait(1);}
	wait(-1);
	while(key_space == 0){wait(1);}
	var my_angle[3];
	my._sound = 1;
	//	my.no_rotate = on;
	var cam2playerdist;
	camera.clip_near = 0;
	my.mass  = 25;
	my.bounce_value = 0.25;
	my.fly_force = 1;
	my.pan = -90;
	physic_object();
	while(1)
	{
		enemy_text.visible == off;
		
		my.enable_scan = on;
		trace_to.x = my.x - cos(my.pan)*140;
		trace_to.y = my.y - sin(my.pan)*140;
		trace_to.z = my.z+ 100;
		trace(my.x,trace_to);
		result = vec_set(camera.x,target.x);
		vec_to_angle(camera.pan,vec_diff(temp.x,my.x,camera.x));
		cam2playerdist = vec_dist(camera.x,my.x);
		my.transparent = off;
		if(cam2playerdist < 100)
		{
			cam2playerdist = clamp(cam2playerdist,0,100);
			my.transparent = on;
			my.alpha = cam2playerdist;
		}
		if(key_cuu == 1)
		{
			my.aabsdist_x = 1*time;
		}
		if(key_cud == 1)
		{
			my.aabsdist_x = -1*time;
		}
		if(key_cul == 1)
		{
			my.aabsdist_y = 1*time;
		}
		if(key_cur == 1)
		{
			my.aabsdist_y = -1*time;
		}
		if(my.floor_dist < 50)
		{
			vec_set(save.x,my.x);
		}
		if(key_space == 1 && my.floor_dist < 50)
		{
			my.gravity_active -= 1.5*time;
		}
		if(my.gravity_active > 10)
		{
			lives -= 1;
			bar_life = 100;
			my.gravity_active = 0;
			my.absdist_x=0;
			my.absdist_y=0;
			my.absdist_z=0;
			wait(1);
			vec_set(my.x,save.x);
			
		}
		vec_set(test.x,my.absdist_x);
		vec_rotate(my.aabsdist_x,vector(camera.pan,0,0));
		
		vec_rotate(my_speed.x,my.pan);
		c_rotate(me,vector((key_a-key_d)*10*time,my_angle.tilt-my.tilt,my_angle.roll-my.roll),glide);
		//special cameras
		if(my.y < -768 && my.x > -512 && my.x < 1072)
		{
			camera.y = -960;
			camera.x = my.x + 240;
			camera.z = my.z + 40;
			vec_to_angle(camera.pan,vec_diff(temp.x,my.x,camera.x));
			my.pan = 0;
			if(my.x > 500)
			{
				camera.y = -816;
				camera.x = 832;
				camera.z = 384;
				vec_to_angle(camera.pan,vec_diff(temp.x,my.x,camera.x));
			}
		}
		if(my.x > 1072 && my.y < -528)
		{
			camera.x = 1256;
			camera.y = -776;
			camera.z = 520;
			vec_to_angle(camera.pan,vec_diff(temp.x,my.x,camera.x));
		}
		if(my.z > 630 && my.x > - 896 && my.x < 1080 && my.y > -256 && my.y < 0)
		{
			my.y = -192;
			my.pan = 180;
			camera.x = my.x;
			camera.y = my.y - 400;
			camera.z = my.z + 400;
			vec_to_angle(camera.pan,vec_diff(temp.x,my.x,camera.x));
		}
		
		wait(1);
		
	}
}
///////////////////////////////////////////////////////////////////////////
function part_alphafade
{
	my.alpha -= 1;
	if(my.alpha == 0){my.lifespan = 0;}
}
function particle_heart
{
	my.size = 40;
	my.bmap = heart;
	my.transparent = on;
	my.alpha = 100;
	my.move = on;
	my.vel_x = random(1)-0.5;
	my.vel_y = random(1)-0.5;
	my.vel_z = 4;
	my.function = part_alphafade;
}
function particle_spike
{
	my.size = 40;
	my.bmap = heart;
	my.transparent = on;
	my.alpha = 100;
	my.move = on;
	my.vel_x = random(1)-0.5;
	my.vel_y = random(1)-0.5;
	my.vel_z = 4;
	my.function = part_alphafade;
}
function bouncer_event
{
	your.gravity_active = -my.power;
	wait(-0.5);
	if(my.floor_dist > 80)//floating blocks
	{
		physic_object();
		while(my.z > -860)
		{
			wait(1);
		}
		ent_remove(me);
	}
}
//uses: power
action bouncer
{
	my.transparent = on;
	if(!my.power){my.power = 5;}
	my.enable_impact = on;
	my.event = bouncer_event;
	while(!player){wait(1);}
	while(player)
	{
		if(vec_dist(my.x,player.x) < 170)
		{
			proc_late();
			bounce_text.visible = on;
		}
		wait(1);
	}
}



panel bar_map
{
	window = 0,0,256,4,bar,bar_life_d,4;
	layer = 0.5;
}
panel heart1
{
	bmap = heart;
	flags = overlay;
	layer = 1;
}
panel heart2
{
	bmap = heart;
	flags = overlay;
	layer = 2;
}
panel heart3
{
	bmap = heart;
	flags = overlay;
	layer = 3;
}
panel heart4
{
	bmap = heart;
	flags = overlay;
	layer = 4;
}
panel heart5
{
	bmap = heart;
	flags = overlay;
	layer = 5;
}
starter display_hearts
{
	while(1)
	{
		if(bar_life <= 0)
		{
			bar_life = 100;
			if(player)
			{
				player.z+=100;
			}
			lives-=1;
		}
		if(lives == 0)
		{
			main();
			lives = 5;
			bar_life = 100;
		}
		bar_life_d = 256-bar_life*2.56;
		bar_map.visible= on;
		heart1.visible = off;
		heart2.visible = off;
		heart3.visible = off;
		heart4.visible = off;
		heart5.visible = off;
		bar_map.pos_x = 60;
		bar_map.pos_y = screen_size.y - 25;
		if(lives >= 5)
		{
			heart5.visible = on;
			heart5.pos_x = 30;
			heart5.pos_y = screen_size.y - 80;
		}
		if(lives >= 4)
		{
			heart4.visible = on;
			heart4.pos_x = 35;
			heart4.pos_y = screen_size.y - 70;
		}
		if(lives >= 3)
		{
			heart3.visible = on;
			heart3.pos_x = 40;
			heart3.pos_y = screen_size.y - 60;
		}
		if(lives >= 2)
		{
			heart2.visible = on;
			heart2.pos_x = 45;
			heart2.pos_y = screen_size.y - 50;
		}
		if(lives >= 1)
		{
			heart1.visible = on;
			heart1.pos_x = 50;
			heart1.pos_y = screen_size.y - 40;
		}
		wait(1);
	}
}
panel bar_map2
{
	window = 0,0,256,4,bar,spike_life_d,4;
	layer = 0.5;
}
panel spike1
{
	bmap = spike;
	flags = overlay;
	layer = 1;
}
panel spike2
{
	bmap = spike;
	flags = overlay;
	layer = 2;
}
panel spike3
{
	bmap = spike;
	flags = overlay;
	layer = 3;
}
panel spike4
{
	bmap = spike;
	flags = overlay;
	layer = 4;
}
panel spike5
{
	bmap = spike;
	flags = overlay;
	layer = 5;
}
/////////
action heart_add
{
	my.facing = off;
	my.oriented = on;
	my.passable = on;
	my.transparent = on;
	my.bright = on;
	my.alpha = 90;
	while(!player){wait(1);}
	while(vec_dist(my.x,player.x) > 40)
	{
		my.pan+=4*time;
		wait(1);
	}
	while(my.alpha > 0)
	{
		if(bar_life > 100)
		{
			lives+=1;
			bar_life = 1;
		}
		my.alpha -= time;
		bar_life += 2*time;
		wait(1);
	}
	ent_remove(me);
}
/////////
starter display_spike
{
	while(1)
	{
		spike_life_d = 256-spike_life*2.56;
		bar_map2.visible= on;
		spike1.transparent = on;
		spike1.alpha = 100;
		spike2.transparent = on;
		spike2.alpha = 100;
		spike3.transparent = on;
		spike3.alpha = 100;
		spike4.transparent = on;
		spike4.alpha = 100;
		spike5.transparent = on;
		spike5.alpha = 100;
		spike1.visible = off;
		spike2.visible = off;
		spike3.visible = off;
		spike4.visible = off;
		spike5.visible = off;
		bar_map2.pos_x = screen_size.x-320;
		bar_map2.pos_y = screen_size.y - 25;
		if(spikes >= 5)
		{
			spike5.visible = on;
			spike5.pos_x = screen_size.x - 30;
			spike5.pos_y = screen_size.y - 80;
		}
		if(spikes >= 4)
		{
			spike4.visible = on;
			spike4.pos_x = screen_size.x - 35;
			spike4.pos_y = screen_size.y - 70;
		}
		if(spikes >= 3)
		{
			spike3.visible = on;
			spike3.pos_x = screen_size.x - 40;
			spike3.pos_y = screen_size.y - 60;
		}
		if(spikes >= 2)
		{
			spike2.visible = on;
			spike2.pos_x = screen_size.x - 45;
			spike2.pos_y = screen_size.y - 50;
		}
		if(spikes >= 1)
		{
			spike1.visible = on;
			spike1.pos_x = screen_size.x - 50;
			spike1.pos_y = screen_size.y - 40;
		}
		wait(1);
	}
}
action enemy
{
	my.enemy_live = 100;
	my.fly_force = 1;
	physic_object();
	while(my.enemy_live > 0 && my.z > -800)
	{
		proc_late();
		if(player != null)
		{
			vec_to_angle(test.pan,vec_diff(temp.x,player.x,my.x));
			c_rotate(me,vec_sub(test.pan,my.pan),glide);
			if(vec_dist(my.x,player.x) < 400)
			{
				enemy_text.visible = on;
				spike_life = my.enemy_live;
				if(trace(my.x,player.x) == 0)
				{
					vec_to_angle(test.pan,vec_diff(temp.x,my.x,player.x));
					c_rotate(player,vec_sub(test.pan,player.pan),glide);
				}
				
				my.aabsdist_x = 0.1;
				if(vec_dist(my.x,player.x) < 200)
				{
					my.aabsdist_z = 0.25;
				}
				if(vec_dist(my.x,player.x) < 100)
				{
					if(my.z > player.z + 10)
					{
						effect(particle_heart,4,player.x,nullvector);
						my.absdist_x = -6;
						bar_life -= 1;
					}
					if(player.z > my.z + 10)
					{
						effect(particle_spike,4,my.x,nullvector);
						player.absdist_x = -6;
						my.enemy_live -= 1;
					}
				}
			}
		}
		vec_rotate(my.aabsdist_x,my.pan);
		wait(1);
	}
	my.active = off;
	ent_create("heart.bmp",my.x,heart_add);
	spikes-=1;
	my.transparent = on;
	my.alpha = 100;
	while(my.alpha > 0)
	{
		my.alpha -= time;
		my.z -= time;
		wait(1);
	}
	ent_remove(me);
}
entity* car_ptr;
var in_car;
action car_ai
{
	physic_object();
	
	var test_1[3] = 280,-70,0;
	var test_2[3] = 280,70,0;
	while(1)
	{
		vec_set(temp.x,test_1.x);
		vec_rotate(temp.x,my.pan);
		vec_add(temp.x,my.x);
		if(c_trace(my.x,temp.x,ignore_me) > 0)
		{
			my.aturndist_pan = 0.25;
			my.speed_x/=1.05;
		}
		vec_set(temp.x,test_2.x);
		vec_rotate(temp.x,my.pan);
		vec_add(temp.x,my.x);
		if(c_trace(my.x,temp.x,ignore_me) > 0)
		{
			my.aturndist_pan = -0.25;
			my.speed_x/=1.05;
		}
		
		my.aturndist_pan/= 1.03;
		my.turndist_pan/= 1.03;
		my.speed_x += (40-my.speed_x)/80;
		my.turndist_pan = clamp(my.turndist_pan,-2.5,2.5);
		wait(1);
	}
}
action car_ai2
{
	my.ambient = 100;
	car_ptr = me;
	car_ai();
}
text press_space{string = "this is a cars using my own(but not very good)physics system.\n
It written at all in C-script and is located in the physics system subfolder\n
press space to continue";font = arial_font;}
text press_space2{string = "features:
 - physic movement
 - physic rotation
 - child&parent
 - open source
 - sounds
 - royalty free
 - realtime customizable skills and flags
 - examples
 
 press space to continue
";font = arial_font;}
text press_space3{string = "this is the player with a Jump&Run script\n press space to start the game";font = arial_font;}
starter camera_function
{
	press_space.visible = on;
	press_space.pos_x = screen_size.x/4;
	press_space.pos_y = screen_size.y-screen_size.y/4;
	while(key_space == 0)
	{
		if(car_ptr)
		{
			vec_set(camera.x,nullvector);
			vec_to_angle(camera.pan,vec_diff(temp,car_ptr.x,camera.x));
		}
		wait(1);
	}
	press_space.visible = off;
	wait(-1);
	press_space2.visible = on;
	press_space2.pos_x = screen_size.x/6;
	press_space2.pos_y = screen_size.y/6;
	while(key_space == 0)
	{
		if(car_ptr)
		{
			vec_set(camera.x,car_ptr.x);
			camera.z+=40;
			vec_set(camera.pan,car_ptr.pan);
			camera.x-= cos(camera.pan)*200;
			camera.y-= sin(camera.pan)*200;
		}
		wait(1);
	}
	press_space2.visible = off;
	wait(-1);
	press_space3.pos_x = screen_size.x/6;
	press_space3.pos_y = screen_size.y/6;
	press_space3.visible = on;
	while(key_space == 0)
	{
		vec_set(camera.x,vector(-896,512,-32));
		if(player)
		{
			vec_to_angle(camera.pan,vec_diff(temp,player.x,camera.x));
		}
		wait(1);
	}
	press_space3.visible = off;
}
//end of the demo script